% *******************************************************************************************************
% PROBLEM 4.1 (b)

% init
clear; close all; clc;

% from analytical derivation
%     fixed points are the columns
FPs = [2 -2; 2 -2];

%     Jacobi-Matrix
fp_idx = 1;
J = [1 -1; 2*FPs(1,fp_idx) 0]
[v,lambda] = eig(J)

fp_idx = 2;
J = [1 -1; 2*FPs(1,fp_idx) 0]
[v,lambda] = eig(J)

% vector field plot
Nv = 40; % Nv * Nv arrows
%     define X and Y grid
[X, Y] = meshgrid(linspace(-3,3,Nv), linspace(-3,3,Nv));
%     plug into the differential equations: dx = y^2 - x, dy = 2x - y
dX = X-Y;
dY = X.^2 - 4;

% plot
figure(1); hold on;
quiver(X, Y, dX, dY, 'k'); % vector field plot
hold on
 xlim([min(min(X)), max(max(X))]); ylim([min(min(Y)), max(max(Y))]);
xlabel('x'); ylabel('y'); title('PHASE SPACE');

%Plot the fixed points
plot(FPs(1,:), FPs(2,:), 'ro', 'MarkerSize', 10)


% example trajectories starting from [x,y] for t=0...30s
[t0,z0] = nde2d_p41b(linspace(0,30,1000), [(-1.5),(-.5)]);
[t1,z1] = nde2d_p41b(linspace(0,30,1000), [(2+.001), (2+.001)]);
[t2,z2] = nde2d_p41b(linspace(0,30,1000), [(-1.2),(-.5)]);

%show saddle
[t3,z3] = nde2d_p41b(linspace(0,30,1000), [(-1.47),(-.692)]);
[t4,z4] = nde2d_p41b(linspace(0,30,1000), [(-1.469),(-.692)]);


figure(1)
% quiver(FPs(1,fp_idx), FPs(2,fp_idx), v(1,1)/3, v(2,1)/3, 'b', 'LineWidth',2);
% quiver(FPs(1,fp_idx), FPs(2,fp_idx), v(1,2)/3, v(2,2)/3, 'r', 'LineWidth',2);

plot(z1(:,1), z1(:,2), 'r-', 'linewidth', 2); % example trajectories, spiral
plot(z0(:,1), z0(:,2), 'g-', 'linewidth', 2); % example trajectories, above saddle
plot(z2(:,1), z2(:,2), 'g-', 'linewidth', 2); % example trajectories, saddle

plot(z3(:,1), z3(:,2), 'b-', 'linewidth', 2); % example trajectories
plot(z4(:,1), z4(:,2), 'b-', 'linewidth', 2); % example trajectories

legend('Vector field','Fixed points', 'Trajectories')

axis([-3 3 -3 3])

figure
subplot(121)
plot(t1,z1), grid on
legend('x(t)','y(t) [x(0) y(0)] = [2.01 2.01] ')
xlabel('t')
ylabel('x(t), y(t)')
xlim([0 12])

subplot(122)
plot(t2,z2), grid on
legend('x(t)','y(t) [x(0) y(0)] = [-1.2 -.5] ')
xlabel('t')
ylabel('x(t), y(t)')
xlim([0 3.7])
