clear all
close all

x0 = 0.1;
N = 400;
r = (0:0.001:1);

for k = 1:size(r,2)
   output(:,k) = logistic(N,r(k),x0);
end

% compute the Lyapunov exponent:

for k=1:size(r,2)
    % compute the map using different initial conditions between 0 and 0.99
    % if x0 is 1, all following y values would be 0 (see logistic.m)
    x=logistic(N,r(k),0.99*rand(1));
    L(k)=mean(log(abs(4*r(k)-8*r(k)*x)));
end

lamda = 1/N * sum(L);

figure;
subplot(2,1,1)
hold all
axis tight
% plot only the interation 200 to 400 to prevent plot of transient points!
for i = 1:size(r,2)
    plot(r(i), output(200:400,i),'b.', 'MarkerSize',2)
end
xlabel('r')
ylabel('Amplitudes')
subplot(2,1,2)
plot(r,L)
xlabel('r')
ylabel('Amplitudes of Lyapunov exponent')
title('Lyapunov exponent for different parameter values');
xlabel('Parameter r')
ylabel('Lyapunov exponent');

